* 3.9+ Redux
Removed all incomplete/broken plus features from 3.9 PLUS final.

Fixed bug in UnlockSystem when using CODE and RO values.
Fixed bug in Event Mode ignoring Unlocks option.
Fixed bug in extra stage reverting the default noteskin.
Fixed bugs in Editor transforms menu.

Added player-side autoplay to allow one player to be under autoplay while the other plays normally. This cannot be turned on or off by attacks.
Added in theme metric to allow mines to break the combo if hit.
Added in theme metric to increment combo on each successful roll hit.
Added in new lua condition; EasterEggs() can now be used to see whether a player has Easter Eggs enabled.
Added ability to set default values to difficulty list using DefaultMeterValues metric in [DifficultyList] in this format: DefaultMeterValues=0,3,6,9,10,5 [beg,easy,med,hrd,cha,edt].
Added ability to have holds OK and NG affect combo (increment and break).
Added Fail AAA, where anything but a Marvelous, Perfect, or OK causes an instant fail.
Added in options to support DDR X difficulties by scaling them down to old DDR values.
Added in MeterType option, which allows for different actions on ScreenSelectMusic (turn red point, meter flashing, etc) based on the meter value and MeterType (DDR, ITG, DDR X) selected.

Rewrote roll note code for better optimization.





* 3.9 PLUS
Fixed bug in BPMDisplay random cycle code.
Fixed bug in PlayerSongs Stepmania.ini option.

Removed AutoPlay from SongOptions (it was broken anyways).
Removed ability for AutoPlay to be loaded from attacks; it was also breaking the normal AutoPlay command.




* 3.9 PLUS RC 5
Fixed DWI files not being loaded as custom songs.
Fixed bug in Edit Menu which caused game to freeze.
Fixed bug with reverting autosync causing global offset to revert back to zero.

Moved some theme options out of Stepmania.ini and into theme metrics (BPMDisplay stuff).

Added ability to turn mem cards on and off via options menu.
Added ability to not drag area selector when laying rolls in editor (ShiftIsUsedAsAreaSelector in Stepmania.ini).
Added ability to make BPM display show up as BPS display under [BPMDisplay] in metrics.

Disabled the checkpoint code outright; there are still too many unsolvable bugs in it for it to be usable in the final release of 3.9 PLUS. Anyone doing their own build can reactivate by looking for 'PIU HOLD DISABLER' in the code and reading the instructions.




* 3.9 PLUS RC 4
Fixed scoring bugs with hold checkpoints if not in PIU or Custom scoring modes.
Fixed yet more bugs in the hold checkpoint code.

Added option to only load existing cache files and not new songs to Stepmania.ini (FastLoadExistingCacheOnly).




* 3.9 PLUS RC 3
Fixed bug in custom song loader crashing when trying to create cache data.
Fixed bugs in hold checkpoint code.
Fixed bugs in Preview Music Mode option in ScreenSelectMusic.
Fixed bugs in Modeswitcher for ScreenSelectMusic.

Readded support for lights driver parallel for Windows; however, this is an unsupported addition and was only added due to popular demand.




* 3.9 PLUS RC 2
Fixed misses not resetting combo when in 'Good doesn't break combo' mode.
Fixed minimum combo digit display not working.
Fixed bug with certain score modes once the lifebar has been depleted.
Fixed Nova/Nova 2 scoring with regards to combo count on jumps/triples/quads.
Fixed more bugs with hold checkpoints.
Fixed music not playing in ScreenSelectCourse.
Fixed Modeswitcher crashing game in extra /extra 2 stages if autogen steps is turned off and the player attempts to switch to a mode with no steps for the selected song.
Fixed song backgrounds not showing up in ScreenSelectMusic if the background cache is enabled.
Fixed bugs in PreviewMusicMode in ScreenSelectMusic.
Fixed bug in ModeSwitcher metric commands.
Fixed DifficultyList bug when hidden difficulty is on.
Fixed bug with PreviewMusicMode not allowing ScreenSelectMusic to switch immediately if the menutimer hits zero.
Fixed assistticks not playing for notes on song row 0.

Added in ability to override score mode defaults for how jumps/triples/quads are counted by the combo (under [ScoringOverride] in metrics).
Added Half Mines mod (randomly removes half the mines in a chart).
Added 'GradeTier03RequiresNoMiss' option to Stepmania.ini. This allows for a proper S rank in PIU simulation (see below). Also, other new scoring options were added related to this.
Added in score multipliers to make PIU Scoring more accurate.
Added in score multipliers for custom scoring.
Added ability to edit Genre information from editor.
Added ability to exclude the roll tapping time from judge rank effects.
Added in ability to reverse lifebar scroll direction in metrics under [LifeMeterBar].
Added in ability to scale text size down in options menus to make everything fit on one line (Same format as multiselect, except you add 'shrink' as the command).
Added in ability for course mode to not be forced to use DDR Extreme scoring.
Added in InputDebounce functionality for arcade machines.


Note for PIU players:
These are the settings you need for proper S ranks in PIU mode. I'm not sure what the percentages for the other tiers are.

GradePercentTier01=1.000000
GradePercentTier02=1.000000
GradeTier02IsAllPerfects=1
GradeTier03RequiresNoMiss=1




* 3.9 PLUS RC 1
Fixed BPM/Tick counts not modifying in edit mode under certain conditions.
Fixed bug with Hidden/Sudden modifiers causing arrows not to appear at all.
Fixed bugs with hold checkpoints.
Fixed bug with hidden notes in regular gameplay.
Fixed bug with toasty appearing on first Marvelous hit.
Fixed bug with non-DDR gametypes crashing in Rave mode.

Renamed Super Dizzy to Confusion.

Disabled ability to set and use Attack Notes. Existing ones are ignored.

Added in ability to display backgrounds on ScreenSelectGroup & ScreenSelectMusic, much like how the banners appear on them and switch depending on the selection.
Added in ability to set life effects & custom scoring effects for hit checkpoints.
Added in ability to specify a maximum length for combo digits & score digits.
Added in ability for SM 4.0 behaviour where any judgment that breaks the combo contributes to the miss combo. Activated in the metrics under [Combo] with 'MissComboIncreasesOnComboBreak=' set to 1.
Added in new fail type -> Miss Combo of 50 misses.




* 3.9 PLUS Beta 4
Partially fixed scoring issues with the negative BPM skips.
Fixed small Dizzy/Super Dizzy bug.
Fixed certain transforms in attacks causing game to screw up arrow data; these transforms in attacks are now ignored.
Fixed small lift note not responding bug in ScreenEdit.

Added in Positive Announcement Only option in Preferences.
Added in options for Announcers and Extra Stage.
Added in ability to hide song info & version info on ScreenTitleMenu.
Added in ability to specify group,<groupname> as a metric conditional.
Added in hold checkpoints in metrics.ini, under [Player]. This causes the holds to more accurately simulate those found in Pump It Up. Activated by setting 'UsePIUStyleHolds=' to 1.
Added in tickcount for hold checkpoints. It uses a system similar to BPMs, and tickcounts can be changed mid song.
Added in PrevScreen metric for ScreenStage.
Added in ability to not have Hidden & Sudden effects have a fade in/out on the arrows, see [ArrowEffects] under the theme metrics.
Added in ability to define column spacing, see [ArrowEffects] under the theme metrics.
Added in ability to activate AutoPlay from course mods by using 'autoplay' as the mod name.
Added in ability to make hidden songs appear from ScreenBranch conditions, command is 'showhidden=true/false'.
Added in ability to turn AutoPlay on/off from Song Options menu.
Added ez2SelectMusic's preview options to ScreenSelectMusic.
Added in Custom Scoring option, controlled via [CustomScoring] in the theme metrics.
Added in TwoPartSelection option for ScreenSelectMusic.

Separated holds and rolls in terms of lifebar effects, percentage weights, etc (they now can be specified independently, rather than using common values in Stepmania.ini).
Small changes made to Static mod.




* 3.9 PLUS Beta 3
Can now specify the allowed mode switcher modes via the theme metrics file.
Can now use 3.95 styled early/late judgments, or just the regular judgements.

Changed SORT LIST functions; no longer loads from SortSongs.crs (file did not load on all systems), and instead the order is specified via the .sm files of a song using the #LISTSORT tag.
Changed TitleScreeen code; can now specify the effects on items in the main menu.
Changed AutoPlay code; if AutoPlay is used at any point to hit a tap note, the score is frozen and the combo reset, a failed grade will be given, and the scores will not be saved

Fixed CMod bug in all versions of 3.9; if a default modifier of 2x is specified, and then C200 is chosen, in game it becomes C400, With a 3x default modifier, C200 becomes C600, and so forth.
Fixed turns in attacks causing game to screw up arrow data; turns in attacks are now ignored.
Fixed Hold/Roll bug in the How To Play Screen; holds and rolls now behave properly.

Added in Extreme 2 style hidden notes, which do not affect scoring but add life to a player that hits them. Note that if you put a regular note and a hidden note together in the same row, the hidden note will have no effect.
Added in ability to specify whether background movies fade on transition.
Added in ability to mask the difficulty of a stepchart; in the SM file, after the difficulty number, add a * before the : (for example, 7*:), and the difficulty will be masked ingame. Using the theme metric 'GenRandomIfHiddenDifficulty', you can set it so that a random value for the meter graphic; otherwise, no graphics will be filled.
Added in ability to have more control over effects of judgements in NoRecover and SuddenDeath; and also the ability to specify initial lifebar start positions.
Added in ability to specify which value constitutes a hot lifebar.
Added in ability to go to Options Menu when in Extra Stage; controlled by StepMania.ini.
Added in ability to change difficulty when in Extra Stage; controlled by StepMania.ini.
Added ability to specify the minimum number of combo digits that appear onscreen at any time.
Added in SuperNova style scoring (no score weight based on note position in song, 10,000,000 max score regardless of difficulty) and Hybrid scoring (score weight based on note position in song, 10,000,000 max score regardless of difficulty).




* 3.9 PLUS Beta 2
Small tweaks made to MemoryCard loader when running in Windows.

Modified negative BPMs causing display errors fix; this only applies if ShowNegative=0 in the theme metrics, under [BPMDisplay].
Modifed Attack Mines and Random Attacks so that the attack data is now loaded from an external file rather than hardcoded. The attacks to be used are set in the RandomAttacks.dat file.
Updated MENUCOLOR with Theme Metric switches to control how it interacts when in Extra Stage mode.

Overhauled part of the Roll code to eliminate the many bugs it introduced in Beta 1.

Added in HoldsToRolls modifier.
Added in ability to disable the playing of the hit mine sound effect in Stepmania.ini
Added in ability to have non-scrolling lifebar by setting LifebarScrolls in theme metrics to 0 (1 to have scroll).
Added in ability for sort subsection to use different fonts per sort.
Added in ability to specify a sort list. The sort list is called via metrics by 'SORT LIST', and the sort list itself is specified in the 'SortSong.crs' file, located in the Songs directory.
Added in modeswitcher function to ScreenSelectMusic, which allows a player to switch between game modes on that screen.
Added in metrics related to judgment and combo positioning when using the centered mod.
Added in banner wheel option to ScreenSelectMusic (Pump It Up style music selection).
Added in ability to load songs via memory card. There are still many bugs in this process.
Added in new display options (only have a song show up on final stage, extra stage, 2 stages left, etc. This is done via #SELECTABLE:1, #SELECTABLE:ES, #SELECTABLE:2, etc. One More Extra Stage would be #SELECTABLE:OMES.




* 3.9 PLUS Beta 1
Fixed .mpg and .mpeg videos freezing during playback when in RandomMovie mode.
Fixed noteskin reverting back to 'default' when in Extra Stages.
Fixed autokeysounds causing a crash by completely ignoring them.
Fixed negative BPMs causing display errors in ScreenSelectMusic when cycling; lowest possible value on BPM display is now 0 (this does not apply to BPM ranges displayed without the cycling effect).
Fixed negative percentages on modifiers not having any impact.

Changed adjustment level of BPM in Edit Mode; using ALT + F7 or ALT + F8 now adjusts by .005 instead of by .010.
Changed maximum step value for Extra Stage 2 auto-selection; will now select from stepcharts with difficulty 8 and 9.
Changed maximum displayed BPM when cycling randomly; new maximum is 999 instead of 600.
Changed music wheel code; songs will automatically switch to extra color only in current style (this means that a 10 in doubles will not cause the color change in single if the single chart is not a 10).
Changed loader splash banner.
Changed lighting code used to control arcade machine lights.
Changed hidden and unlock systems to allow option for Event Mode to ignore these statuses, and show the songs anyways.
Change in the AutoSync code.

Added in fade for first video when in RandomMovie mode.
Added in RandomColor to theme metrics; this now allows randomly cycling BPMs to have a seperate color.
Added Static mod.
Added Invert mod, back ported from StepMania 4.0.
Added in AttackMines mod, which does the same thing as stepping on a mine in Mungyodance2 (instead of losing life, causes a mod to affect you). Permission to do this was given by the programmer of this feature in Mungyodance2. Stepping on these mines will not affect your lifebar, but will affect your Grade and Score.
Added in RandomAttacks mod, which causes random attacks to play during the song, updating evey x seconds which is set via Stepmania.ini
Added wraparound cycling in the Edit Menu.
Added in ability to choose whether Dark will be used by default in the Extra Stages via Stepmania.ini.
Added in support for Lift Notes; behave exactly as they do in SM 4.0.
Added option to control the cycle speed of the Randomized BPM Display; four settings (slow, normal, fast, vfast). Normal is the SM default, and vfast is very similar to that of DDR Extreme.
Added in ability to specify the color of a song on the MusicWheel via the #MENUCOLOR tag in a .sm file. For this to work correctly, the proper format is '#MENUCOLOR:r,g,b,a;', where r,g,b,a are values from 0.0 to 1.0. R is red, g is green, b is blue, and a is ambience. Also, specifying a valid name will work. The names are: white, black, brightred, brightgreen,brightblue, red, green, blue, yellow, pink, purple, orange, cyan, seagreen, ddrgreen, ddryellow, ddrblue, ddrpurple. Also, you can set extra (Extra Stage color) and group (set a file that defaults to Extra Stage color back to the group color).
Added in ability to not save Catalog.xml via Stepmania.ini.
Added in ability to have Extra1.crs and Extra2.crs in the main Songs directory, and load them if these files are not found in the song directory when ES and OMES are activated.
Added in roll support for 3.9.
Added in ability to not play Attack Sounds, even if the files exist for the theme.
Added in theme option to not show '???' in BPM Display random cycle (under [BPMDisplay]).
Added in Sort by Genre option.


IMPORTANT! You must update the metrics for any noteskin to include rolls and lifts, or else SM 3.9 PLUS will crash! Also, the Cache must be deleted prior to the first loading!




* 3.9 rc4
Windows: Fixed DLL problem on older systems.
Linux: Fix statically linked libavcodec.




* 3.9 rc3
Fixed change song speed menu codes starting with change difficulty menu codes.
Fixed memory leak when beginner helper is in use.
Fixed crash due to high song meter values.
Fixed reading UTF-8 lyrics.
Fixed crash related to BMS loading.
Fixed memory leak reading ZIPs.
Fixed handling corrupt banner cache.
Fixed score classifications when playing long and marathon songs.
Fixed crash selecting Random with no songs.
Fixed songs with a non-zero initial BPM segments.
Editor: Fixed laying hold notes with shift-0.
Windows: Disabled parallel port lights driver due to GPL-incompatibility.
Windows: Worked around Realtek AC97 audio driver bug.
Windows: Fixed thread handle leak.
Added some fallbacks for note color NoteSkin elements.
Linux: Fixed some GCC 3.4 compilation problems.
Linux: Added extra autoconf checks for Lua and TLS.
OSX: Switch back to OS X installer.




* 3.9 rc2
Fixed stage count problems.
Fixed crash when portal is used with no open sections.
Fixed obscure leap year problems.
Fixed crash when looping movies.
Fixed grades being too high.
Fixed saving "GradePercentTier" to StepMania.ini.
Fixed more half-doubles loading problems.
Fixed incorrect credit deduction when in free play + DelayedCreditReconcile.
Fixed Pump half-doubles KSF reading.
Fixed "Assertion 'iNumTapsInRow > 0' failed".
Windows: Worked around GTXP audio driver bug.
Windows: Fixed minor DirectSound underrun recovery problems.
Linux x86-64: Fixed Fedora build problems.
Linux x86-64: Fixed crash in vssprintf.
Linux x86-64: Fixed crash handler.




* 3.9 rc1
Fixed movie frame semaphore timeout.
Fixed stretched images becoming slightly transparent.
Fixed MP3 sync for cut MP3s (TM4 Discow Moscow).
Fixed ScreenRaveOptions text.
Fixed image scaling causing slight transparency.
Fixed slow "random vanish".
Fixed some MPEG4 movies skipping frames and not looping cleanly.
Windows: Intel 82845G reverted back to D3D.
OSX: Fixed "Illegal instruction" on G3s.
Added OSC3 "Sabishii Kute Loneliness" translit.
Added kanji for Foonmix songs.




* Alpha 24
Fixed music sample not starting when a song is selected quickly.
Fixed swapped NG/OK scoring.
Fixed double-width slash character.
Fixed loading half-doubles from KSFs.
Fixed legacy songs not finishing with the song background.
Fixed character rendering artifacts when a freeze segment lies on beat 0.
Fixed screen overlay graphics not being reloaded on theme change.
Fixed joystick mapping problems.
Windows: DirectSound underrun fixes.
Windows: Fixed refresh rate setting in D3D.
Windows: Fixed crash when fullscreen D3D window loses focus.
Windows: Use OpenGL for Intel 82845G.
Linux: Fixed GTK window not being centered.
Added OSC3 Red Sun translit.
Player 2 Back button now defaults to NumLock instead of Insert.
More options are saved to the profile.




* Alpha 23
Fixed garbled mono sounds.
Fixed graphics being reset after exiting menus that don't affect graphics.
Fixed fail mode being used in Oni mode.
Fixed "by Unknown artist" autogen Oni courses.
Fixed codes on ScreenTitleMenu when UseDedicatedMenuButtons is on.
Fixed autogen course scoring.
Fixed "MemoryCardOsMountPointP#" in Windows.
Fixed extra stage music wheel entry not always being in a section.
Fixed TM5 "GO", "Lady Madonna" wheel sorting due to extra spaces before titles.
Fixed profile options being saved in jukebox mode.
Fixed score shown on the music wheel in Oni mode.
Fixed TexCoordArrayFromRect crash.
Fixed CourseEntryDisplay::LoadFromTrailEntry crash.
Fixed course editor saving crash.
Windows: Fixed apostrophe inserting a quote in text entry.
Windows: Improved DirectSound underrun recovery.
OSX: Fixed some banners not being displayed.
Disabled timer header for options screens that have no timer.
Always load song banners as 32bpp, to speed up the music wheel.
Allow selection of both 1280x960 (for CRTs) and 1280x1024 (for LCDs).
Fixed OSC1 "Love Hina" title.
Added OSC2 "Dejiko to Gema" translit and correct "Assami" -> "Asami".
Added OSC3 "E-Paksa", Naofumi Hataya, "ukifune" kanji and translits.




* Alpha 22
Fixed menu timer running song roulette on course selection.
Fixed OnCommand being played twice when song BGA layers first gain focus.
Fixed options screen not always importing course difficulty.
Fixed secondary Pump controller auto-mapping.
Fixed negative DP scores (good attacks) being graded E instead of D.
Fixed ScreenSelectStyle tween-out.
Fixed course sort crashes.
Fixed missing graphics on rankings screen.
Fixed error reason not being displayed on failure opening SM/DWI/BMS files.
Fixed editor crash in "Show Steps Statistics" on 16-foot and higher songs.
Fixed scrollbar flickering.
FFMpeg 0.4.9 is now required (previously 0.4.8).
Linux: Fixed libjpeg searching.
Linux: ALSA device can be changed via the SoundDevice option in StepMania.ini.
Stats are now rendered with XSL.
Title menu accepts MenuLeft and MenuRight.
NoteSkin step metrics are now controllable per-judgement.
When no profile is loaded in event mode, save scores with name "EVNT".
Added translits: tsuyoizo hoshi no senshi, Guri Guri, Miyagawa Akira.
Added "Yuujou" kanji.
Adjusted "hoshi no umi kaze no yume" translit.
When in "SM options navigation", pressing start in the options menus only moves
  to the "exit" row, instead of going directly to the next screen.  This ensures
  that both players have a chance to set options.
Theme change: _shared fonts in "Numbers" are now named "_numbers".  (This is to
  differentiate them from the _shared fonts in Fonts.)  .redir files need updating.




* Alpha 21
Fixed edits causing malformed DWI tags to be written.
Fixed course selection music in SMMAX2.
Fixed paletted textures.
Fixed some OpenBSD compilation issues.
Fixed difficulty changes not always visible in the course display.
Fixed crashes on song reload.
Fixed edits causing malformed DWI tags to be written.
Fixed doubles premium.
Fixed blending artifacts on paletted images.
Fixed player options menu if START is pressed quickly.
Fixed "Foo BG.png" not always detected as a background.
Fixed song graphic search aborting early.
Disabled memory card reading by default.
Optimized Catalog.xml writing.
Changing course difficulties no longer retweens the course entry list.
Linux: Fixed crash in 2.6 when NPTL is not in use.
Linux: Fixed crash when trying to read directories with -r+x permissions.
Linux: Fixed crash when reading from directories without read permissions.
Linux: Fixed signal handling in 2.6 kernels when LinuxThreads is in use.
Linux: Fixed linking against libjpeg.
Editor: Fixed spurious assist ticks at start of Play.
Editor: Fixed "m" not rewinding the sample music.
Editor: Fixed crash when a button is held during the lead-in while recording.
SMMAX2: Fixed course selection music.
Added TournaMix 5 transliterations.
Theme changes:
  file "ScreenGameplay extra life frame" -> "ScreenGameplayExtra life frame"
  file "ScreenGameplay score score frame" -> "ScreenGameplayExtra score frame"
  all "arcade" files and metrics -> "regular"
  metrics "ScreenGameplay::LifeFrameExtra*" are now "ScreenGameplayExtra::LifeFrame"; same for all gameplay extra stage metrics
  metric "CDTitleSpinSeconds" -> "CDTitleFrontCommand" and "CDTitleBackCommand".




* Alpha 20
Fixed image loading crashes.
Fixed GIF loading.
Fixed crash after failed image loads.
Fixed missing images in ScreenSelectMusic.
Fixed assertion failure in easy course mode.
Fixed profile step totals.
Fixed OpenGL crashes in X11R6.7.0.
Fixed toasties not always showing.
Fixed cursor not moving if p2 is on beginner when p1 moves to page 2 during difficulty selection.
Fixed statistics for the current game not being saved if Alt-F4 is pressed mid-game.
Fixed difficulty icon placement in reverse course songs.
Fixed "Exception: CryptAcquireContext" error.
Stats.html is no longer written by default.
Editor: Fixed assertion failure playing long songs.
Steps and calories still count after failing a stage.
ScreenSelectCourse is now based on ScreenSelectMusic.
Added Yuki Matsuoka kanji.
Added Oni course autogen by artist.
Courses now support the #COURSETRANSLIT tag; works identically to .SM #TITLETRANSLIT.




* Alpha 19b
Fixed loading images with incorrect file extensions.
Fixed CDTitle rendering regression.
Fixed songs not being reselected correctly from the sort menu.
Fixed missing ScreenEditCoursesMenu metrics.
Fixed editor menu and course editor not wrapping.
Fixed stage screen back transition being skipped.
Optimized Catalog.xml writing.




* Alpha 19
Unknown audio types in songs is no longer a fatal error.
Incorrect DifficultyIcon state count is no longer a fatal error.
Fixed DifficultyIcon staying hidden when no song is selected.
Fixed "volume not ready" dialogs.
Fixed song scores not being found.
Fixed music wheel speed regression.
Fixed some fading banners.
Fixed machine high score index when players both get the same high score.
Fixed floating tails in reverse boomerang.
Fixed hold heads cycling through all note types while held.
Fixed timer on character selection.
Fixed character rendering in How To Play.
Fixed profile deletion not deleting edits.
Fixed character model rendering artifacts when a freeze segment lies on beat 0.
Fixed BPM/offset changing during gameplay.
Added "Save Stats" option (available under "Other Options").
Added "easy" course mode (opposite to difficult courses).
Stomp is easier in dance-double.
Improvements to planted and twister transforms.
Latency improvements in ALSA for Linux 2.4 kernels.
Removed SaveToProfile option; it hasn't done anything for a while (options are always saved to profile).




* Alpha 18
Fixed "FilenameDB::AddFile()" crash.
Fixed evaluation grade announcer not playing.
Fixed "-0.002582" crashes in gameplay and editor.
Fixed game data not being found correctly when launched from SMPackage.
Fixed model rendering glitches.
Fixed menu timer having a shadow even though MenuTimer::OnCommand says not to.
Added "kono omoi o tsutaetai" and "Ai (Chuu Seishin)" kanji.
Editor: Fixed crash when reverting and the selected notes weren't found.
Editor: Fixed reverting goes to the wrong song if the selected song has a blank description.
OSX: Changes to try to fix skipping on older machines.




* Alpha 17
Fixed reversed NG and OK grading weights.
Fixed "iCpuSkill<NUM_SKILL_LEVELS" crash.
Fixed hang when an error is encountered reading an INI file.
Windows: Reduce garbled sounds on quit.
Reenable threaded movie decoding by default (disabled causes skipping).
Linux: fix crash handler killing the parent process.
Linux: prevent SDL from accidentally trying to use svgalib or aalib.
Dithering optimizations, to speed up 16-bit loading.
Sound locking rewrite, to reduce skipping.
Hold note optimizations.
Theme: Reasonable defaults are now provided for OptionOrder metrics.
Editor: Fixed crash after reverting a difficulty change.
Duplicate step patterns for the same song are now changed to edits, instead of being shifted to the next difficulty.
Song and course scores are no longer lost if a song is removed.




* Alpha 16
Fixed grade sort showing only "???".
Fixed "BEGINNER" difficulty not being loaded correctly.
Fixed "Assertion 'this' failed" in summary evaluation.
Fixed extra stage modifiers being saved to an active profile.
Fixed rate display in song options.
Fixed slowdown when movie decoders fail to load.
Fixed assist tick not being played on row 0.
Fixed sample music looping in the editor.
Fixed crash when song paths (eg. #CDTITLE) begin with "../".
Experimental: movies are not decoded in a thread by default.
Windows: Disabled DirectShow movie decoder.
Windows: Fixed crashinfo.txt corruption in Win98.
Linux: improve crash handler behavior if libraries (eg. ALSA) fail assert().
OSX: Fixed crashinfo.txt generation taking too long.
OSX: Fixed system appearing to hang after generating crashinfo.txt.




* Alpha 15
Fixed dancing character rendering.
Fixed not playing announcers in demonstration.
Fixed grade sort.
Replaced 5x speed mod with 4x, to line up with the editor.
Fixed sound when moving up in options.
Fixed switching songs in course mode before the last note can be missed.
Fixed stealth.
Fixed extra stage survive time being covered up by the transition.
Fixed crash loading DWIs with invalid #FREEZE values.
Don't parse subtitles from "#TITLE" tags in SM files (use #SUBTITLE).
SMPackage: fixed installing "NoteSkins/foo/bar" deletes all other note skins in "NoteSkins/foo".
Tornado doubles is easier.
Mac: Fixed screenshots.
Mac: Fixed "seconds != (time_t)-1" crash.
Linux: Fixed screensaver disabling causing screen flicker; reenabled by default.




* Alpha 14
Fixed evaluation voltage result.
Fixed "Visualizations/foo.avi/ isn't a directory" crash.
Fixed course selection list scrolling.
Fixed timing when a freeze lies before or on the first BPM segment (Black Cat).
Fixed Direct3D screenshot crashes.
Fixed crash on movie decode DirectShow fallback.
Fixed evaluation crash.
Fixed judgement window problems when using music rate modifier.
Fixed CDTitle paths not resolving correctly if they begin with "./".
"RADEON Mobility 7500" uses Direct3D.
SMMAX2: Fixed ScreenEvaluation score label.
Editor: Ctrl+Insert, Ctrl+Delete moves BPMs and stops.
Editor: Fixed crash with "EDIT" difficulty.
Editor: Fixed note skin reverting to default after play.
Enable all players in course editor.
Fixed sample music sync when MP3 "Info" tags are present.
When shuffling both players, transform identically.
Autoplay text no longer obscures lyrics.
Transition between course songs slightly faster.
Linux: Disabled code to disable X screensaver; it causes flicker.
Linux, Mac: crashinfo.txt is now written to the user's home directory.




* Alpha 13
MP3s should now be read and synced identically to DWI.
Fixed profile options crashes.
Fixed input after changing video settings or theme.
Fixed options menu crashes when only P2 is active.
Fixed "no holds" option.
Fixed notes becoming 1/192 of a beat off sync during courses.
Fixed editor desync when low-quality resampling is in use.
Fixed backwards course difficulty codes.
Fixed crashes with "MS Video 1" AVIs.
Fixed reading very small SMZIPs.
Fixed not delaying BACK on the music select screen for keyboard input.
Fixed Quick arrows in Pump.
Fixed crash if the system clock moves backwards.
Fixed crashes, bogus radar results after selecting "no" to "save changes?" gameplay prompt.
Added "Cross" modifier.
Don't show "#SELECTABLE:NO" songs in the jukebox or demonstration.
Don't show "OK" if blind.
Don't play the same random BGA twice in a row.
Replaced "DWIPath" with "AdditionalFolders"; separate multiple paths with commas.
Editor: Added "reload from disk".
Editor: Allow showing BGAs during replay.
Editor: F5/F6 changes steps in order.
Editor: fixed receptor flash in play/record mode.
Windows: Fixed keys getting stuck after dialogs.
Mac: Use CoreAudio for the sound driver.
Reduced skipping when playing announcers during gameplay.
Music wheel input cleanup.
Song backgrounds are no longer kept in memory, to prevent excessive memory use.
Scores are now written in XML to improve compatibility between versions.
Data in "memcard.ini" is now stored in profiles.
Screenshots are now saved as JPEGs (hold left shift and press PrScr to get a BMP).
Reload Songs/Courses now shows progress.




* Alpha 12
Added NoJumps, NoHands, NoQuads.
Tweaked planted, twister, echo with mines.
Improved assist tick precision.
Improved stomp and quick in doubles.
Fixed receptors not flashing before beat 0.
Fixed editor sync bug (caused by the sample music seek fix).
Fixed missing Sound Options metric.
Fixed not showing danger in FailEndOfSong after everyone has failed.
Fixed crash on profile creation if no name is entered.
Fixed frame rate issues with boomerang.
Fixed crashes after using "create from copy" in the editor menu.
Fixed evaluation crash after playing a song with a meter value greater than 12.
Fixed left/right act as up/down on the options menu.
Fixed music wheel load speed issues.
Fixed music wheel glitches.
Fixed music wheel section colors.
Fixed music wheel skips when starting sample music.
Fixed "Couldn't find primary display driver; logging all drivers".
Fixed file creation in Win9x.
Fixed input being queued while dialog boxes have focus.
Linux: support sound hardware that only support 48khz output.
Linux: Fixed "Killed" on ^C.
Linux: Fixed directory creation problems.
Linux: Partial vsync support for nVidia cards (need to restart if changed in the menu).
Linux: Disable X11 screensavers.
Linux: Center SDL loading windows.




* Alpha 11
Added "Fast load" option: if enabled, songs are not checked for changes on load.
Added "Attract Sound Frequency" option.  By default, attract sounds are only played once every four cycles of the idle loop.
Fixed translation loading.
Fixed sample music seeking in MP3s.
Fixed directory creation.
Fixed "Can't use turns as battle attacks" in courses.
Fixed crash after deleting profiles.
Fixed AdditionalSongFolders.
Fixed "No Holds".
Fixed some cases of "abnormal program termination" windows instead of the crash handler.
Windows: upgraded to Vorbis 1.0.1.
Removed "10+FootInRed"; use ExtraColorMeter theme metric instead.
Write files in a safer way, to prevent data loss on crash.
Loading optimizations.
Editor: added collapse left transform.
Added translits: Masahiro Andoh, Sakura Saku, Toshio Masuda, Tsuneo Imahori,
  Michiru Yamane, Negai, Hatsumi Morinaga, Yuzo Koshiro, Jaurim, Mirai Yosouzu II,
  Masaya Matsuura.




* Alpha 10
Fixed GhostArrowRow::CopyTweening crash.
Fixed sort changing with dedicated menu buttons off.
Fixed "Attack.cpp:24 Assertion 'fEndBeat >= fStartBeat' failed".
Added separate screenshot sound.
High score saving fixes.
Fixed cdtitles.
Fixed options menu explanation tweening.
Added SMZIP package support.




* Alpha 9
Fixed DWI writing assertion failure.
Fixed NoteDisplay::SetActiveFrame crash.
Fixed "intro.wav" being used as song music.
Fixed autogen hold notes.
Fixed song options screen on 2P side.
Added echo, planted, stomp, twister transforms.
Nerfed Quick transform.
Fixed movie background case-sensitivity.
Fixed "noholds" crash.
Fixed START on music scroll and credits screen.
Fixed demo play being counted to Players' Best.
Fixed crash when pressing left/right when on "EXIT" in options.
Fixed BeginnerHelper "Model::LoadMilkshapeAscii Could not open ''".
Hopefully fixed weird newlines in SMs for real.
Don't allow TwoPlayerRecovery in Oni.
Don't allow stalling the music select timer indefinitely.
Changed pump->dance autogen.
Allow "#FFFF80FF", "#FFFF80" in color metrics (vs. 1.0,1.0,0.5,1.0).
Linux: fixed backtraces on 2.6 kernels.
Linux: Fixed crash handler compile on RedHat.
Mac: Fixed support for OS X 10.2.7 and above.
Mac: Removed libraries/frameworks from installer. (They are now included in the application package.)
Fixed Back Ji Young translit.
Added translits: Tsugaru Kaikyou no Onna, Black Cat, Dream Possession,
  Deluxe, Aaron Kwok, The Strong Jaeger, ~Ai no Big Band~, Renai Revolution
  21, Deluxe, Kaniyuuutsu, Oni no Ran, This Is Unmei, Michyo, Amuro Namie,
  Dal Ah Dal Ah, "Heaven of Hoodlums" Haruka Kanata, Midsummer's Night
  Midsummer's Dream, Hanabi (Lange Remix), Hyakugojyuuichi, Dicky Cheung,
  Yoo Seung Jun, Journey to the West, Full Moon o Sagashite (Smile),
  Leon Lai, KOTOKO & Hiromi Sato, Syunikiss, M-FLO loves Crystal Kay.




* Alpha 8
Fixed hidden not turning off.
Fixed '0' crashing the editor (again).
Fixed some movies not looping.
Fixed "new record" always showing in evaluation.
Fixed default NoteSkin being hidden.
Fixed BACK from the Select Game menu going to the options menu.
Fixed changing to life bar from song options menu in Oni mode.
Fixed small options screen memleak.
Fixed saved steps in the editor disappearing.
Fixed auto selection of last edited steps after saving in editor.
Fixed lyrics with changed music rates.
Fixed How To Play crash in non-Dance games.
Fixed crash when pressing keys for a game that don't exist in the play style (eg. Solo buttons in single play).
Improved DWI/SM file error recovery.
Added support for up to 6 joysticks.
Added screen centering adjustment.
Added input test screen.
Added auto-mappings for NTPAD and PSXPAD.
Added option for silent attract sequence.
Readd sound volume menu option.
Default sound volume set to full.
Linux: don't show debug info to output unless ShowLogOutput pref is enabled.
ALSA: Many fixes.
ALSA: Now supports hardware mixing.
ALSA: Lower latency sound when running on a new 2.6 Linux kernel.
ALSA: Modularized; binaries compiled with ALSA will work on systems without ALSA installed.
Added 4th note, 8th note, beamed 8th note, beamed 16th note, flat, natural sharp and double-width forward slash glyphs.
Added TM4+ glyphs.
Added name entry announcer.
Don't show the danger animation if failure is disabled.
Only lock and fail in fail-end-of-song if both players are failing at the same time.
Tweaked "Failed halfway" announcer.
Always show the default noteskin first.
Autogen improved for converting to note types with fewer columns.
Removed delay after choosing in editor menus.
Select course screen shows high scores on the music wheel.
Don't write empty lines to stats.html.
Fail-end-of-song fails after the current song in course play.
Maintain precise sync through corruptions in Oggs.  (Can't do that with MP3!)
Don't fail if songs refer to images that can't be loaded.




* Alpha 7
Fixed style and difficulty selection announcers.
Fixed characters not showing up.
Fixed editor record misalignment.
Screenshots moved back to PrntScrn (also cmd-F12 for Macs).
Screenshots are now saved in a "Screenshots" subdirectory.
Finish playing sounds before quitting from the main menu.
Options menus now (almost) completely themable.
Several modifier fixes (drunk, tornado, etc).
Fixed "press start again for more options" showing in the editor.
Fixed second controllers with secondary auto-mappings automapping incorrectly.
Fix SuddenHidden.
More editor sync fixes.
Only auto-map joysticks if attached joysticks change.
Added subtitle to editor.
Fixed movie flushing; fixes odd 1-frame videos.
Write #FILE tag to DWIs.
Fixed assertion failure with joysticks with more than one hat.
Sped up select music screen.




* Alpha 6
Fixed "fabs(fOffBy)<10" crash.
Fixed gray arrows in perspective modes.
Fixed options screen crashes when playing on the second palyer side.
Fixed stats.html quoting.
Fixed pump center button not working.
Fixed second extra stage glitch when playing in a song group with only long songs.
Fixed slow saving in the editor.
Fixed slow doubles autogen.
Fixed Perfects having a base score of 10 instead of 9 when Marvelous is always on (not set to "course only").
Fixed OK being worth 3 DP instead of 2 DP when Marvelous is set to "course only" and we're not playing a course.
Fixed danger animation throwing off background movie sync.
Fixed input mapping axis problems.
Fixed display glitches in evaluation when playing songs with no steps.
Improved quality music rate changing.
Added title menu switch game code (LRLLRRLR).
Added "hallway" and "distant" mods.
Added double-width ? and !.
Magic Dance is playable without character models.
Refuse to run in Linux unless at least SDL 1.2.6 is installed (since we won't work).
Movie sync fixes.
OSX: Handle vsync.
Theme change: Removed ScreenSelectStyle5th; use ScreenStyleMaster instead.
Theme change: ScreenSelectStyle and ScreenSelectDifficulty graphics are now eg "icon1.png", "picture2.png", "icon2.png", not "icon single.png".




* Alpha 5
Fixed low-quality banners.
Fixed lines in hold notes again (hopefully).
Fixed options menu crashes.
Fixed movie sync issues and crashes.
Fixed editor help menu running off the screen.
Fixed default sort glitches.
Fixed bad performance in 9x.
Fixed mini.
Fixed music rate options glitches.
Fixed showcourse/noshowcourse (Caprice).
Fixed dancing character speed.
Fixed player's best showing unplayable songs.
Fixed rare crash while quitting from the editor.
Fixed unusual concentration of mines after hold notes.
Fixed Jenny Rom bug: fix songs with '=' in the pathname not being loaded from cache.
Added SM 3.0 scores file reading.
Added tempo compress/expand in the editor.
Added basic profiles support.
Added translits for Tentaikansoku's artist, Kouji Kondou, and Otome no Michi.
Moved ShowStats to graphic options menu.
Removed IgnoreJoyAxes; no longer needed.
Improved lyrics effect.
Harder Brake.
Scoring fixes while using transformations.




* Alpha 4
Fix different taps when on the same row as a hold start.
Fix deleting notes in the editor.
Fix "Marvelous" showing with mines when marvelous grading is disabled.
Fix some editor sync issues.
Fix black lines in hold notes.
Fix "reload songs" erasing scores.
Fix mine crashes.
Fix dancing characters not resetting between songs in a course.
Fix glitches in the select group screen.
Fix multiple Steps assigned the same difficulty when loading from BMS files.
Fix SM file not being written in the editor if the song has a DWI file with an extension in caps.
Add tipsy, split, alternate, blind.
Add generated "stats.html".
Add beginner helper.
Add a dancing character to the how to play screen.
Add F5/F6 to switch Steps in editor.
Add announcers "gameplay oni fail", "gameplay oni fail halfway" and "gameplay combo overflow".
Add FFMpeg-based movie decoding.
Add left+right+start to move back in options menus when in arcade-style navigation.
Add some more Korean characters.
Don't clear area before recording in the editor.
Require a combo before regaining life after bottoming out.
Always load fonts in 16bpp.
Fixed course writing errors.




* Alpha 3
Fixed courses crashing.
Fixed extra stage crash.
Fixed errors reading sounds causing a crash.
Fixed Caprice.
Fixed duplicate 'jukeboxmenu right' elements.
Fixed grading when using transforms.




* Alpha 2
Somewhat fixed "NORMAL/DIFFICULT" not working on course player options screen (it would default to what 2P was set to regardless of player being present or not).
Added 5th mix scoring option (somewhat buggy).
Added mines transform (somewhat buggy).
Show offset change when using autosync/changing offset during a song.  It shows on the "Save changes" screen.
Added cleared extra stages/failed extra stages unlock options.
Added experimental course editor.
Music wheel now goes to first available song when you pass a long version song and have one stage left.
Various other bugfixes.




* Alpha 1
Fixed Oni mode overriding chosen life meter choice.
Fixed some select music screen speed issues.




* 2003-08-03
Slightly optimized wheel loading times.
Added progressive stage lifebar.
Fixed stage counter not updating when long versions are a final stage.
Fixed memory leaks regarding unlock screen.
Lifebar difficulty now goes up to 16.




* 2003-07-31
Fixed song options screen crashing in course mdoe.
Fixed cache directory not being created correctly.
Fixed music wheel crashes.
Fixed #DISPLAYTITLE file ignoring being case-sensitive.
Fixed odd image detection problems .
Fixed timer stalling during roulette.
Fixed negative chaos values.
Fixed rotated banners during courses.
Added progressive lifebar motion.
Added random caprice courses.
Sound quality experiment.
Added JUSTICE.




* 2003-07-28
Fixed fallback banner not always showing.
Fixed banner crashes.
Fixed scoring when using transforms.
Fixed hold notes not losing life if you release them during a freeze that lies at the exact start of the hold.
Fixed autosync in non-1x music rates.
Fixed fail adjustment after changing difficulty in the player options menu.
Fixed problems with unbuffered input devices.
Fixed not recording AAAA over AAA.
Added controller config screen tweening.
Added "courses only" option for marvelous judgement.
Added Taku Iwazaki, Hideki Naganuma, Blümchen.
Challenge notes no longer make a song red.
Adjusted difficult course behavior for random songs.
Setting a background brightness of 0 disables backgrounds completely.
SMPackage: Allow disabling comments.
SMPackage: Uninstall packages before installing new ones.
Evaluation radar fixes.
Never use files listed in (otherwise unused) #DISPLAYTITLE/#DISPLAYARTIST DWI fields as song banners.




* 2003-07-15
Fixed "OFF" not working in player options menus.
"Cancel all codes" code maintains default note skin.
Fixed theme metrics not reloading after 42 days of gameplay.
Fixed animations becoming cohppy after several days of play.
Fixed Pump pad-related crashes.
Fixed cosmetic banner problems while selecting course.
Fixed color key in fading rotated banners.
Fixed ampersands in the loading screen showing up as underlines.
Fixed banners fading out and in after changing sort.
Fixed sample music playing after changing sort.
Added Maaya Sakamoto.
Added "e=mc² mix".
Added threaded input.




* 2003-07-09
Fixed crash on extra stage.
Fixed invalid glyph when showing negative scores in eval.
Fixed CDTitle backsides.
Fixed ScreenStage/lyric crash.
Fixed player settings being reset if you back out of the player options menu.
Fixed player options menu items not showing on the 2p side.
SMMAX2: Fixed menu music looping and graphics alignment.
Support up to 32 buttons per joystick.
Allow configuring bit depth for movies.
Cope with broken drivers that don't support GL_UNSIGNED_SHORT_1_5_5_5_REV.




* 2003-07-07
Default score for non-Oni courses is 573000, not 573.
Always use 16-bit textures for movies (faster).
Show easy icon for songs with 1-foot light steps.
Fixed NoteFieldPositioning crash.
Fixed ranking course alignment.
Fixed extra stage difficulty.
Fixed crashes after editing.
Fixed lyric crash.
Fixed DWI writing losing some 96th notes.
TM4: Added Lee Jung Hyun, Tamaki Nami, Tomoe Shinohara, soramimi keeki,
  The Peace, tentaikansoku.
Added a special case "Sana" translit for White Lovers.

DWI reading: Implement `192nds', <46> jumps, and <4!46!6> hold jumps.
<4006> (containing 0s) is still treated as 192nds, for backwards
compatibility.

DWI writing: Implement <2468> jumps.

Themes:
The ScreenEvaluation graphics "bar actual", "bars possible", "bonus frame",
"grade frame", "percent frame", "survived frame", "win", and "win frame";
and the ScreenSelectMusic graphics "difficulty frame", "meter frame" and
"score frame" have been split into separate graphics for each player.




* 2003-06-30
Fixed "save changes?" not reverting.
Fixed editor creating duplicate notes.
Fixed "hh:mm.ss" time display (was showing "hh:mm.00".)  Switch at an hour, not 100 minutes.
Fixed default fail type sometimes not working.
Fixed default note skin not working.
Fixed autoplay weirdness in editor.
Fixed crash with very long hold notes.
Fixed radar weirdness with corrupt songs.
Fixed endless crash.
Fixed random banner.
Fixed keys getting stuck if we lose focus while they're depressed.
Fixed losing the last buffer of sound from a sample.
Fixed difficulty display being shown when not on a song.
Added sorts by meter.
Added more TM4 kanji.
Added Pokèmon -> Pokémon.
Retain the difficulty specified in extra1/extra2.crs.
Improve fallback if we can't set up an OpenGL window.
Movie optimizations.
Theme change: MusicSortDisplay icons are now in separate files.
Scoring fixes.
Implement "Right" transform.
Return to the select course screen after name entry in event mode.
Allow ISO-8859-1 in DWIs.
Don't show all sorts with left-right-start; hit up-down-up-down to get the full list.




* 2003-06-23
Fixed music wheel sort bugs.
Fixed OKs being worth 3 in course mode even when marvelous is off.
Fixed editor changes remain when exiting without saving.
Fixed Jukebox text.
Fixed S3 ProSavage crashes.
Fixed alt key sticking after alt-enter.
Fixed Hiroko Kasahara kanji.
Fixed missing instructions screen.
Fixed overriding fail mode after it's been changed by the user.
Fixed scoring problems with nonstop courses.
Movie optimization experimentation (report any changes).
Added song credit editing to the editor.
Added TM4 translits.
Play menu music when in SORT sort.
Removed fade between random movies (decoding two movies is too slow).
Removed "Use BG if no banner".
SMPackage: compress files aren't already compressed.
SMPackage: add comments.




* 2003-06-18
Fixed more GL_NO_ERROR problems.
Fixed tween crash in MAX3000.
Fixed "continue holding" text not tweening off (again).
Fixed doubles jukebox.
Fixed alt-enter stopping music in demonstration.
Fixed assist tick turning off between songs in a course.
Fixed scoring rounding error.
Fixed losing keyboard input when changing graphics settings.
Fixed expand.
Note quantize fixes.
More #DISPLAYBPM fixes.
Make MAX3 work (subtle timing fixes).
Banner cache for group and course banners.
Add option screen scrolling.
Add icon for SMMAX2.
Add TM4#1 kanji.
Add note selection to the player options menu.
Add new music wheel sorts.
Add Alt-F7/F8 for finer BPM adjustment.
Add group select tweening.
Detect oversize banners and rotated banners that aren't exactly square.
Rewrite input code (again).
Handle group banners in the parent dir.




* 2003-06-11
Fixed not flushing GL error state.
Oha, Tokimeki Memorial translation fixes.
Choose default settings based on video card and system memory.
Default hold note window increased.
Fixed combo announcer.
Fixed game types being available when they shouldn't.
Fixed lyric position in reverse.
Add banner caching.
Fixed #SELECTABLE and #DISPLAYBPM writing.
Changed screenshots to print screen.
Added kanji for "home version" and "Four Seasons".
Fixed autoplay in the editor causing all presses to be "marvelous".
Fixed "1.0x" not working in courses.
Added alt-F11, F12 to change beat 0 offset in 1ms increments.
Changed nonstop scoring: all nonstop courses sum to 100mil points.
Fixed OK being counted as a perfect in course mode, instead of a marvelous.
Don't save song changes after gameplay by default.
Added various Korean characters.
Stop sample music when entering play or record mode.




* 2003-05-31
Fixed C200 and 8.0 scroll speed options loading backwards.
Fixed movies not working in D3D.
Fixed hidden, sudden, etc. with changed scroll speeds.
Fixed "continue holding BACK" text not fading out on end of song.
Fixed course contents not masking correctly.
Fixed some Voodoos not being detected as such.
Fixed time spacing being very slow in TM3 Stoic.
Fixed alt+tabbing crash on Voodoo3.
Fixed CDTitles.
Changed 1280x1024 to 1280x960.
Fixed group banners not named "banner" not being seen by the select course screen.
Hopefully fixed a crash loading paletted images.
Fixed changing note skins in the editor.
Removed limit of 1200 songs in the music screen.
Only show an easy icon for songs that have beginner steps.
Add some Korean characters.
Add .3x and .5x music rate (sounds bad at the moment).




* 2003-05-28
Don't force note skin to "note" in the editor, since not all note types have a note skin by that name.
Fixed occasional assertion failure during the demonstration and jukebox.
Fixed BPM not being updated correctly in the select music screen.
Fixed some tweens not always finishing cleanly.
Fixed select screen announcer playing too early.
Fixed not counting hold scores when autoplay is on.
Fixed lyrics during courses.
Scale course names during records display.
Fixed "show transliterations" option being backwards.
Add auto-conversion from EUC-JP for KSFs (no fonts yet).
Added Pump half-doubles.
Don't auto-classify images containing "-char".
Graphics auto-adjustment for very slow cards.
Possibly fixed some fullscreen toggling issues.
Fixed crash pressing 0 in the editor.
Disable banner preloading by default.
Automatic configuration for some adapters.
Maximum number of random backgrounds is configurable.




* 2003-04-20
Fix crash when lyrics are too close together.
Fix the options menu when entered via the operator key.
Fix options menu crash.
Fix stage screen for course mdoes.
Fix select style comment.
Fix demonstration crash.
Fix difficulty display in course selection after changing difficulty.
Fix scrollbar oddness when there are exactly 13 items onscreen.
Add a theme metric editor.
Update editor info after each keypress, so changes don't appear lagged.
Stop the clock for dead players.
Add temporary workaround for strange nVidia driver problem.
Improve UI for options that go off the edge of the screen.
Rotations in metrics are now specified in degrees, not radians.
How To Play screen.
New dither algorithm.
Add missing kanji.
Move data and INI files into data/.
Only show a song as difficult if it's difficult in the current play mode.
Fixed name entry/credits crash.
Fixed CDTitle rotation speed.
Fixed CDTitles not being loaded on first play.
Fixed course selection screen crash.
Fixed blink.
Fixed P2 lifebar not tweening.
Fixed endless mode banner display.
Fixed MISS.
Fixed judge difficulty setting.
Fixed option to not show the song options screen.
Fixed long/marathon balloons.
Fixed rate changing rounding error that caused .9 to actually play at .8.
Don't cache banners by default.
Fixed diagonal banners in BGAs.




* 2003-03-27
Fixed missing credits.
Added lyric support.
Sample music fixes.
Transitions are themable.
Song options screen is optional.
Movie optimizations.
Handle movies with capitalized extensions.
Editor fixes when in custom play rates.
Added "Skippy" transform.
Fixed "aoi" glyph.
New banner for Random.
Don't throw if a movie fails to load.
Windows: Fixed loading window in taskbar in 9x.
Added skip window.
Added missing "kuru" kanji.
Crowd cheer at beginning of gameplay.
Jumps are now graded on the score that completes the row, not the minimum score of the row.
Jumps count as 2 toward combo, but 1 toward judgement totals.
Perfect or better increments combo in oni.
OK worth 3 in course modes.
Maybe fix some sound skips.
Fixed the null sound driver busy looping.
Numbers starting with a decimal point are still in the NUM folder.
Scoring changes.
Hold note life fills instantly instead of gradually.
Texture usage and loading optimizations.
Lots of theme changes.
Nonstop courses can be made more difficult; use the same codes as selecting a song.




* 2003-03-06
Fixed SaveMachineScoresToDisk crash.
Fixed "Each Tomorrow" translation.
Fixed course title not showing on ranking screen.
Fixed files in global CDTitles directories.
Fixed title sorting.
Fixed default difficulty selection.
Fixed difficulty icon positioning when reverse changes during a course.
Fixed sounds playing twice in difficulty select.
Fixed rate changing in the editor.
Reset options when backing out of a song.
"Ignore JoyAxes" also ignores Z axes.
Added long and marathon balloons.
Joystick fixes.
Try not to repeat songs in random courses.
Try not to show courses that can't be played.
Handle banners that are exactly 320x240.
Don't accept button presses in name entry after pressing start.
Course kanji fixes.
Little removes HoldNotes that don't start on a beat.
Allow showing dance points instead of percentage in oni.
Write #BEGINNER to DWIs (hope this is OK).
Write #CDTITLE to DWIs.
Added Tokimeki Memorial translations.
Don't throw if songs are missing #BPMS.
Guess titles from directory names if #TITLE is missing.
Don't change the sample position of songs that actually have a sample start of 0.
GLDirect bug workarounds.
Remove song length limits.




* 2003-02-21
Fixed corrupt Joint Premium image.
Fixed autosync.
Fixed movies breaking if we change video modes while one is playing.
Fixed Aoi Shoudou, Door of Magic, Sanae Shintani.
Fixed Omega glyph asymmetry.
Fixed course final evaluation stage count.
Fixed name entry in Pump mode.
Fixed edit menu default selection.
Fixed oni percentage updating after holds.
Fixed battery count when over 4 lives (going from "5" to 3 bars is weird).
Fixed eval radar overflow.
Fixed SMMAX2 menu backgrounds/
Removed toggle for using translits when characters are missing (useless).
Both hollow and filled star and heart glyphs.
Scoring fixes.
Course enhancements and fixes.
Added new transforms.
Added "L'amour et la liberté".
F9 works in the course menu (but only for song titles, not for course titles).
Style select icon cleanup.
NG time for holds changed from 180ms to 120ms.
Note skins can now be selected per-player on the player options screen.
Oni life meter fixed.
Some shadow fixes.
Separate course and song translations.
Fixes for guessed sample music start.
Subst songs even if they already have a translit line; too many songs have hacked titles with transliterations that need to be substituted.
Use DirectInput for joysticks; hopefully this will fix some of the converter problems people are having.




* 2003-02-12
Fixed handling of corrupted music files (was causing the radar glitch).
Fixed edit sample fade-out.
Fixed Dancing Pompokolin.
Fixed options menu when in arcade input style.
Fixed extra stage selection.
Synchronization tweaks.
Don't accept a held START for 750 ms after selecting a song (but you can release it and re-press it to get it immediately).
Name entry honors the timer preference.
Judge window default tweaks.
Added Hypnotic Crisis and a few Señoritas (and others; won't list them all here).
Added several course translations.
Allow changing sorts when in EX selection mode.
Super-shuffle fixes.
Might have fixed that extra "OTHER" thing.
Fading banner transparency with colorkeyed images fixed.
Translations are in a separate file.
Translations can be toggled in the Appearance Options menu, or press F9 in the Select Music screen.
If we don't have all characters for a translation, fall back on the transliteration.
Don't translate a song field at all if there's already a transliteration.
Different color for the extra stage that will lead to EX2.
Fail mode can be set in Machine Options.
Game options screen can be disabled.




* 2003-02-09
Fixed assertion failure under GLDirect.
Fixed ignoring commented-out lines in SM/DWIs.
Fixed restoring from a maximize.
Fixed crash when BACK is pressed while roulette is spinning.
Fixed score breakage when BACK is held in the final eval screen.
Fixed songs with beginner steps being marked easy.
Fixed not writing autogen notes to DWIs.
Fixed extra stage selection (challenge == hard).
Fixed score overflow for songs with meter > 10.
Fixed BGANIMATIONS at beat 0 being shown early (includes movies).
Fixed editor tick timing.
Typo song title "Aio Shoudou" is recognized.
Yozora no Mukou corrected.
Handle "Doors of Magic" (along with "Door of Magic").
Large ID3V2 tags don't make mp3s not work.
No OK if a hold tap wasn't pressed (oops).
New editor menu.
Editor optimizations for songs with an absurd number of bpm changes/stops.
Editor crash fixes.
New jukebox mode.
F6 to save screenshot.
Separate options menu.
Allow user-selected extra stage.
Default texture depth is 16-bit (try 32-bit; it loads faster and looks much better).
Ignore beginner steps for difficulty sort.
Music wheel can be set to have sections for ABC only.
Stop playing with the video mode when in a window.
Misc. course fixes.
Challenge is good enough for an extra stage.
Turn off autofail by default for beginner/easy; turn off failure completely for beginner first stage.
Check the alternative song folders for extra stage courses.
NoteSkin format change (don't count on it not changing again).
Handle alternate difficulty names (easy vs basic vs light, etc) in course files.
Don't make the gain-life song between Oni courses if we didn't actually gain any life.
Added a 24-pixel font, so the group select screen kanji don't look ugly.

